/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import AnyOfnumberstring from './AnyOfnumberstring';
import OrderTypes from './OrderTypes';
import UnfilledTimeout from './UnfilledTimeout';

/**
 * The ShowConfig model module.
 * @module model/ShowConfig
 * @version 2021.12-dev21
 */
class ShowConfig {
    /**
     * Constructs a new <code>ShowConfig</code>.
     * @alias module:model/ShowConfig
     * @param version {String} 
     * @param apiVersion {Number} 
     * @param dryRun {Boolean} 
     * @param stakeCurrency {String} 
     * @param stakeAmount {module:model/AnyOfnumberstring} 
     * @param stakeCurrencyDecimals {Number} 
     * @param maxOpenTrades {Number} 
     * @param minimalRoi {Object} 
     * @param unfilledtimeout {module:model/UnfilledTimeout} 
     * @param timeframeMs {Number} 
     * @param timeframeMin {Number} 
     * @param exchange {String} 
     * @param forcebuyEnabled {Boolean} 
     * @param askStrategy {Object} 
     * @param bidStrategy {Object} 
     * @param botName {String} 
     * @param state {String} 
     * @param runmode {String} 
     */
    constructor(version, apiVersion, dryRun, stakeCurrency, stakeAmount, stakeCurrencyDecimals, maxOpenTrades, minimalRoi, unfilledtimeout, timeframeMs, timeframeMin, exchange, forcebuyEnabled, askStrategy, bidStrategy, botName, state, runmode) { 
        
        ShowConfig.initialize(this, version, apiVersion, dryRun, stakeCurrency, stakeAmount, stakeCurrencyDecimals, maxOpenTrades, minimalRoi, unfilledtimeout, timeframeMs, timeframeMin, exchange, forcebuyEnabled, askStrategy, bidStrategy, botName, state, runmode);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, version, apiVersion, dryRun, stakeCurrency, stakeAmount, stakeCurrencyDecimals, maxOpenTrades, minimalRoi, unfilledtimeout, timeframeMs, timeframeMin, exchange, forcebuyEnabled, askStrategy, bidStrategy, botName, state, runmode) { 
        obj['version'] = version;
        obj['api_version'] = apiVersion;
        obj['dry_run'] = dryRun;
        obj['stake_currency'] = stakeCurrency;
        obj['stake_amount'] = stakeAmount;
        obj['stake_currency_decimals'] = stakeCurrencyDecimals;
        obj['max_open_trades'] = maxOpenTrades;
        obj['minimal_roi'] = minimalRoi;
        obj['unfilledtimeout'] = unfilledtimeout;
        obj['timeframe_ms'] = timeframeMs;
        obj['timeframe_min'] = timeframeMin;
        obj['exchange'] = exchange;
        obj['forcebuy_enabled'] = forcebuyEnabled;
        obj['ask_strategy'] = askStrategy;
        obj['bid_strategy'] = bidStrategy;
        obj['bot_name'] = botName;
        obj['state'] = state;
        obj['runmode'] = runmode;
    }

    /**
     * Constructs a <code>ShowConfig</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ShowConfig} obj Optional instance to populate.
     * @return {module:model/ShowConfig} The populated <code>ShowConfig</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new ShowConfig();

            if (data.hasOwnProperty('version')) {
                obj['version'] = ApiClient.convertToType(data['version'], 'String');
            }
            if (data.hasOwnProperty('strategy_version')) {
                obj['strategy_version'] = ApiClient.convertToType(data['strategy_version'], 'String');
            }
            if (data.hasOwnProperty('api_version')) {
                obj['api_version'] = ApiClient.convertToType(data['api_version'], 'Number');
            }
            if (data.hasOwnProperty('dry_run')) {
                obj['dry_run'] = ApiClient.convertToType(data['dry_run'], 'Boolean');
            }
            if (data.hasOwnProperty('stake_currency')) {
                obj['stake_currency'] = ApiClient.convertToType(data['stake_currency'], 'String');
            }
            if (data.hasOwnProperty('stake_amount')) {
                obj['stake_amount'] = ApiClient.convertToType(data['stake_amount'], AnyOfnumberstring);
            }
            if (data.hasOwnProperty('available_capital')) {
                obj['available_capital'] = ApiClient.convertToType(data['available_capital'], 'Number');
            }
            if (data.hasOwnProperty('stake_currency_decimals')) {
                obj['stake_currency_decimals'] = ApiClient.convertToType(data['stake_currency_decimals'], 'Number');
            }
            if (data.hasOwnProperty('max_open_trades')) {
                obj['max_open_trades'] = ApiClient.convertToType(data['max_open_trades'], 'Number');
            }
            if (data.hasOwnProperty('minimal_roi')) {
                obj['minimal_roi'] = ApiClient.convertToType(data['minimal_roi'], Object);
            }
            if (data.hasOwnProperty('stoploss')) {
                obj['stoploss'] = ApiClient.convertToType(data['stoploss'], 'Number');
            }
            if (data.hasOwnProperty('trailing_stop')) {
                obj['trailing_stop'] = ApiClient.convertToType(data['trailing_stop'], 'Boolean');
            }
            if (data.hasOwnProperty('trailing_stop_positive')) {
                obj['trailing_stop_positive'] = ApiClient.convertToType(data['trailing_stop_positive'], 'Number');
            }
            if (data.hasOwnProperty('trailing_stop_positive_offset')) {
                obj['trailing_stop_positive_offset'] = ApiClient.convertToType(data['trailing_stop_positive_offset'], 'Number');
            }
            if (data.hasOwnProperty('trailing_only_offset_is_reached')) {
                obj['trailing_only_offset_is_reached'] = ApiClient.convertToType(data['trailing_only_offset_is_reached'], 'Boolean');
            }
            if (data.hasOwnProperty('unfilledtimeout')) {
                obj['unfilledtimeout'] = UnfilledTimeout.constructFromObject(data['unfilledtimeout']);
            }
            if (data.hasOwnProperty('order_types')) {
                obj['order_types'] = OrderTypes.constructFromObject(data['order_types']);
            }
            if (data.hasOwnProperty('use_custom_stoploss')) {
                obj['use_custom_stoploss'] = ApiClient.convertToType(data['use_custom_stoploss'], 'Boolean');
            }
            if (data.hasOwnProperty('timeframe')) {
                obj['timeframe'] = ApiClient.convertToType(data['timeframe'], 'String');
            }
            if (data.hasOwnProperty('timeframe_ms')) {
                obj['timeframe_ms'] = ApiClient.convertToType(data['timeframe_ms'], 'Number');
            }
            if (data.hasOwnProperty('timeframe_min')) {
                obj['timeframe_min'] = ApiClient.convertToType(data['timeframe_min'], 'Number');
            }
            if (data.hasOwnProperty('exchange')) {
                obj['exchange'] = ApiClient.convertToType(data['exchange'], 'String');
            }
            if (data.hasOwnProperty('strategy')) {
                obj['strategy'] = ApiClient.convertToType(data['strategy'], 'String');
            }
            if (data.hasOwnProperty('forcebuy_enabled')) {
                obj['forcebuy_enabled'] = ApiClient.convertToType(data['forcebuy_enabled'], 'Boolean');
            }
            if (data.hasOwnProperty('ask_strategy')) {
                obj['ask_strategy'] = ApiClient.convertToType(data['ask_strategy'], Object);
            }
            if (data.hasOwnProperty('bid_strategy')) {
                obj['bid_strategy'] = ApiClient.convertToType(data['bid_strategy'], Object);
            }
            if (data.hasOwnProperty('bot_name')) {
                obj['bot_name'] = ApiClient.convertToType(data['bot_name'], 'String');
            }
            if (data.hasOwnProperty('state')) {
                obj['state'] = ApiClient.convertToType(data['state'], 'String');
            }
            if (data.hasOwnProperty('runmode')) {
                obj['runmode'] = ApiClient.convertToType(data['runmode'], 'String');
            }
        }
        return obj;
    }


}

/**
 * @member {String} version
 */
ShowConfig.prototype['version'] = undefined;

/**
 * @member {String} strategy_version
 */
ShowConfig.prototype['strategy_version'] = undefined;

/**
 * @member {Number} api_version
 */
ShowConfig.prototype['api_version'] = undefined;

/**
 * @member {Boolean} dry_run
 */
ShowConfig.prototype['dry_run'] = undefined;

/**
 * @member {String} stake_currency
 */
ShowConfig.prototype['stake_currency'] = undefined;

/**
 * @member {module:model/AnyOfnumberstring} stake_amount
 */
ShowConfig.prototype['stake_amount'] = undefined;

/**
 * @member {Number} available_capital
 */
ShowConfig.prototype['available_capital'] = undefined;

/**
 * @member {Number} stake_currency_decimals
 */
ShowConfig.prototype['stake_currency_decimals'] = undefined;

/**
 * @member {Number} max_open_trades
 */
ShowConfig.prototype['max_open_trades'] = undefined;

/**
 * @member {Object} minimal_roi
 */
ShowConfig.prototype['minimal_roi'] = undefined;

/**
 * @member {Number} stoploss
 */
ShowConfig.prototype['stoploss'] = undefined;

/**
 * @member {Boolean} trailing_stop
 */
ShowConfig.prototype['trailing_stop'] = undefined;

/**
 * @member {Number} trailing_stop_positive
 */
ShowConfig.prototype['trailing_stop_positive'] = undefined;

/**
 * @member {Number} trailing_stop_positive_offset
 */
ShowConfig.prototype['trailing_stop_positive_offset'] = undefined;

/**
 * @member {Boolean} trailing_only_offset_is_reached
 */
ShowConfig.prototype['trailing_only_offset_is_reached'] = undefined;

/**
 * @member {module:model/UnfilledTimeout} unfilledtimeout
 */
ShowConfig.prototype['unfilledtimeout'] = undefined;

/**
 * @member {module:model/OrderTypes} order_types
 */
ShowConfig.prototype['order_types'] = undefined;

/**
 * @member {Boolean} use_custom_stoploss
 */
ShowConfig.prototype['use_custom_stoploss'] = undefined;

/**
 * @member {String} timeframe
 */
ShowConfig.prototype['timeframe'] = undefined;

/**
 * @member {Number} timeframe_ms
 */
ShowConfig.prototype['timeframe_ms'] = undefined;

/**
 * @member {Number} timeframe_min
 */
ShowConfig.prototype['timeframe_min'] = undefined;

/**
 * @member {String} exchange
 */
ShowConfig.prototype['exchange'] = undefined;

/**
 * @member {String} strategy
 */
ShowConfig.prototype['strategy'] = undefined;

/**
 * @member {Boolean} forcebuy_enabled
 */
ShowConfig.prototype['forcebuy_enabled'] = undefined;

/**
 * @member {Object} ask_strategy
 */
ShowConfig.prototype['ask_strategy'] = undefined;

/**
 * @member {Object} bid_strategy
 */
ShowConfig.prototype['bid_strategy'] = undefined;

/**
 * @member {String} bot_name
 */
ShowConfig.prototype['bot_name'] = undefined;

/**
 * @member {String} state
 */
ShowConfig.prototype['state'] = undefined;

/**
 * @member {String} runmode
 */
ShowConfig.prototype['runmode'] = undefined;






export default ShowConfig;

